<?xml version="1.0"?>
<scpd xmlns="urn:schemas-upnp-org:service-1-0">

  <specVersion>
    <major>1</major>
    <minor>0</minor>
  </specVersion>



  <actionList>

    <action>
      <name>PowerOn</name>
      <argumentList>
         <argument>
           <retval />
           <name>Power</name>
           <relatedStateVariable>Power</relatedStateVariable>
           <direction>out</direction>
          </argument>
      </argumentList>
    </action>

    <action>
      <name>PowerOff</name>    
      <argumentList>
         <argument>
           <retval />
           <name>Power</name>
           <relatedStateVariable>Power</relatedStateVariable>
           <direction>out</direction>
          </argument>
      </argumentList>
    </action>

    <action>
      <name>SetChannel</name>
      <argumentList>

        <argument>
         <name>NewChannel</name>
         <retval />
         <relatedStateVariable>Channel</relatedStateVariable>
         <direction>out</direction>
        </argument>

        <argument>
        <name>Channel</name>
          <relatedStateVariable>Channel</relatedStateVariable>
          <direction>in</direction>
        </argument>
      </argumentList>
    </action>

    <action>
      <name>IncreaseChannel</name>     
       <argumentList>
        <argument>
         <name>Channel</name>
         <retval />
         <relatedStateVariable>Channel</relatedStateVariable>
         <direction>out</direction>
        </argument>
       </argumentList>
    </action>

    <action>
      <name>DecreaseChannel</name> 
      <argumentList>
        <argument>
         <name>Channel</name>
         <retval />
         <relatedStateVariable>Channel</relatedStateVariable>
         <direction>out</direction>
        </argument>
       </argumentList>
    </action>

    <action>
      <name>SetVolume</name>
      <argumentList>

        <argument>
         <name>NewVolume</name>
         <retval />
         <relatedStateVariable>Volume</relatedStateVariable>
         <direction>out</direction>
         </argument>
        <argument>
        <name>Volume</name>
          <relatedStateVariable>Volume</relatedStateVariable>
          <direction>in</direction>
        </argument>
      </argumentList>
    </action>

    <action>
      <name>IncreaseVolume</name>       
      <argumentList>

        <argument>
         <name>Volume</name>
         <retval />
         <relatedStateVariable>Volume</relatedStateVariable>
         <direction>out</direction>
         </argument>
       </argumentList>

    </action>

    <action>
      <name>DecreaseVolume</name>       
      <argumentList>

        <argument>
         <name>Volume</name>
         <retval />
         <relatedStateVariable>Volume</relatedStateVariable>
         <direction>out</direction>
         </argument>
      </argumentList>
    </action>

  </actionList>




  <serviceStateTable>

    <stateVariable sendEvents="yes">
      <name>Power</name>
      <dataType>Boolean</dataType>
      <defaultValue>0</defaultValue>
    </stateVariable>

    <stateVariable sendEvents="yes">
      <name>Channel</name>
      <dataType>i4</dataType>
        <allowedValueRange>
          <minimum>1</minimum>
          <maximum>100</maximum>
          <step>1</step>
        </allowedValueRange>
      <defaultValue>1</defaultValue>
    </stateVariable>

    <stateVariable sendEvents="yes">
      <name>Volume</name>
      <dataType>i4</dataType>
        <allowedValueRange>
          <minimum>0</minimum>
          <maximum>10</maximum>
          <step>1</step>
        </allowedValueRange>
      <defaultValue>5</defaultValue>
    </stateVariable>

  </serviceStateTable>

</scpd>
















